
/*
Perk "M18 ClayMore" stworzono na potrzeby Call of Duty Mod by QTM. Peyote
Zastosowanie: Dostajesz mine przeciwpiechotna, ktora mozesz zdetonowac:
-Recznie - dostajesz joysticka (jako NOZ) ktory mozesz uzyc w kazdej chwili. Gdy zginiesz a bomba nie zdetonowana, idzie na straty
-Automatycznie - wybuch wyzwalany jest przez zblizenie sie przeciwnika
Autor perku: Hleb
*/

#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <codmod>
#include <engine>
#include <hamsandwich>
#include <fakemeta_util>

#define TASK_PLANTING 841

new const perk_name[] = "M18 ClayMore"
new const perk_desc[] = "Dostajesz mine przeciwpiechotna ktora mozesz recznie lub automatycznie zdetonowac"

enum {DETONATE_NONE = 0, MANUAL_DETONATE, SCAN_DETONATE}  // rodzaj detonacji
enum {PLANT_NONE = 0, PLANTING, PLANTED}
new bool: ma_perk[33], M18_planting[33], M18_detonate[33], ma_bron[33], sprite_blast, sprite_white, bool: freezetime;

public plugin_init() 
{
	register_plugin(perk_name, "1.0", "Hleb")
	
	cod_register_perk(perk_name, perk_desc)
		
	RegisterHam(Ham_Item_Deploy, "weapon_tmp", "Weapon_Deploy", 1);
	RegisterHam(Ham_Item_Deploy, "weapon_knife", "Weapon_Deploy_Knife", 1);
	RegisterHam(Ham_Spawn, "player", "Odrodzenie", 1);
	
	register_event("HLTV", "NowaRunda", "a", "1=0", "2=0");
	register_event("ResetHUD", "ResetHUD", "abe");
	register_logevent("PoczatekRundy", 2, "1=Round_Start"); 
	register_forward(FM_CmdStart, "CmdStart");
	register_forward(FM_SetModel,"fwSetModel",1);
	
	register_think("claymore", "M18_Detonate_Scan")
	
}
public cod_perk_enabled(id)
{
	ma_perk[id] = true
	ma_bron[id] = true
	M18_planting[id] = PLANT_NONE;
	M18_detonate[id] = DETONATE_NONE;
	Odrodzenie(id)
}
public cod_perk_disabled(id)
{
	cod_take_weapon(id, CSW_TMP)
	ma_perk[id] = false
	ma_bron[id] = false
}
public plugin_precache()
{
	precache_model("models/QTM_CodMod/v_claymore.mdl")
	precache_model("models/QTM_CodMod/p_claymore.mdl")
	precache_model("models/QTM_CodMod/w_claymore.mdl")
	precache_model("models/QTM_CodMod/v_claymore_radio.mdl")
	sprite_blast = precache_model("sprites/dexplo.spr");
	sprite_white = precache_model("sprites/white.spr") ;
}
public Odrodzenie(id)
{
	if(ma_perk[id] && ma_bron[id])
		cod_give_weapon(id, CSW_TMP)
}
public Weapon_Deploy(ent)
{
	new id = get_pdata_cbase(ent, 41, 4);
	if(ma_bron[id])
	{
		set_pev(id, pev_viewmodel2, "models/QTM_CodMod/v_claymore.mdl");
		set_pev(id, pev_weaponmodel2, "models/QTM_CodMod/p_claymore.mdl");
		set_pev(id, pev_weaponanim, 3);
	}
	return PLUGIN_CONTINUE;
}
public Weapon_Deploy_Knife(ent)
{
	new id = get_pdata_cbase(ent, 41, 4)
	if(ma_bron[id] && M18_detonate[id] == MANUAL_DETONATE)
	{
		set_pev(id, pev_viewmodel2, "models/QTM_CodMod/v_claymore_radio.mdl");
		set_pev(id, pev_weaponanim, 2);
	}
}
public CmdStart(id, uc_handle)
{	
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE
		
	if(!is_user_connected(id))
		return PLUGIN_CONTINUE
		
	if(get_user_weapon(id) == CSW_TMP)
	{
		if(!ma_perk[id])
			return PLUGIN_CONTINUE
		
		if(!ma_bron[id])	
			return PLUGIN_CONTINUE

		new M18_ent = fm_find_ent_by_owner(-1, "weapon_tmp", id);
		new Button = get_uc(uc_handle, UC_Buttons)
		new OldButton = pev(id, pev_oldbuttons)	
		
		if(Button & IN_ATTACK && !(OldButton & IN_ATTACK) && !M18_planting[id] && !freezetime) 
		{
			set_pev(id, pev_weaponanim, 1);
			Button &= ~IN_ATTACK;
			set_uc(uc_handle, UC_Buttons, Button);
			message_begin(MSG_ONE, get_user_msgid("BarTime"), {0, 0, 0}, id)
			write_byte(1)
			write_byte(0)
			message_end()
			M18_planting[id] = PLANTING
			set_task(1.0, "claymore_planting", id+TASK_PLANTING)
			return FMRES_IGNORED
		}
		if(M18_planting[id] == PLANTING && (Button & (IN_USE | IN_ATTACK2 | IN_BACK | IN_FORWARD | IN_CANCEL | IN_JUMP | IN_MOVELEFT | IN_MOVERIGHT | IN_RIGHT)))
		{
			set_pev(id, pev_weaponanim, 0);
			remove_task(id+TASK_PLANTING)
			message_begin(MSG_ONE, get_user_msgid("BarTime"), {0, 0, 0}, id)
			write_byte(0)
			write_byte(0)
			message_end()
			M18_planting[id] = PLANT_NONE
			return FMRES_IGNORED
		}
		if(M18_ent)
			cs_set_weapon_ammo(M18_ent, -1);
		cs_set_user_bpammo(id, 23, -1)	
	}
	else if(get_user_weapon(id) != CSW_TMP && ma_bron[id])
	{
		if(task_exists(id+TASK_PLANTING))
		{
			remove_task(id+TASK_PLANTING)
			message_begin(MSG_ONE, get_user_msgid("BarTime"), {0, 0, 0}, id)
			write_byte(0)
			write_byte(0)
			message_end()
			M18_planting[id] = PLANT_NONE
			return FMRES_IGNORED
		}
	}
	if(get_user_weapon(id) == CSW_KNIFE && M18_detonate[id] == MANUAL_DETONATE && get_uc(uc_handle, UC_Buttons) & IN_ATTACK)	
	{
		new M18_ent1 = find_ent_by_class(-1, "claymore");
		if(M18_ent1 && pev(M18_ent1, pev_owner) == id)
		{
			new entwpn = fm_find_ent_by_owner(-1, "weapon_knife", id)
			if(entwpn)
				set_pdata_float(entwpn, 48, 1.5+3.0, 4)
			set_pdata_float(id, 83, 1.5, 4)
			set_pev(id, pev_weaponanim, 3)
			M18_Detonate_Manual(M18_ent1)
		}
	}
	return FMRES_IGNORED
}
public ResetHUD(id)
{
	M18_detonate[id] = DETONATE_NONE;
	M18_planting[id] = PLANT_NONE;
}
public claymore_planting(id)
{
	id-=TASK_PLANTING
	
	M18_planting[id] = PLANTED
	new Float:origin[3], Float:vAngle[3];
	entity_get_vector(id, EV_VEC_origin, origin);
	entity_get_vector(id, EV_VEC_v_angle, vAngle);
		
	new ent = create_entity("info_target");
	entity_set_string(ent ,EV_SZ_classname, "claymore");
	entity_set_edict(ent ,EV_ENT_owner, id);
	vAngle[0] = 0.0;
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_TOSS);
	entity_set_origin(ent, origin);
	entity_set_vector(ent, EV_VEC_angles, vAngle);
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX);
	entity_set_model(ent, "models/QTM_CodMod/w_claymore.mdl");
	drop_to_floor(ent);
	
	new ent1 = fm_find_ent_by_owner(-1, "weapon_tmp", id);
	if(ent1 && M18_planting[id] == PLANTED)
		cod_take_weapon(id, CSW_TMP)
	M18_Menu(id)
	
}
public fwSetModel(ent, model[])
{
	new id = pev(ent, pev_owner)
	if(M18_planting[id] != PLANTED)
		return FMRES_IGNORED
		
	new szClass[32];
	pev(ent, pev_classname,szClass, 31);
	if(equal(szClass,"weaponbox"))
	{
		if(!equal(model, "models/w_tmp.mdl"))
			return FMRES_HANDLED;
		dllfunc(DLLFunc_Think, ent);	
	}
	return FMRES_IGNORED;
}
public M18_Menu(id)
{
	new menu = menu_create("Wybierz tryb detonacji:", "M18_Menu_Handle");
	menu_additem(menu, "Automatyczna (radar)");
	menu_additem(menu, "Reczna (radio)");	
	menu_setprop(menu, MPROP_EXIT, MEXIT_NEVER);
	
	menu_display(id, menu);
}
public M18_Menu_Handle(id, menu, item)
{
	switch(item)
	{
		case 0: 
		{
			M18_detonate[id] = SCAN_DETONATE
			client_print(id, print_chat, "[COD:MW] Wybrales automatyczna detonacje!")
			client_print(id, print_chat, "[COD:MW] Wybuch wyzwalany jest przez zblizenie sie wroga do miny!");
			new m18 = find_ent_by_class(0, "claymore")
			if(m18)
				if(pev(m18, pev_owner) == id)
					entity_set_float(m18, EV_FL_nextthink, halflife_time() + 0.1);
		}
		case 1:
		{
			M18_detonate[id] = MANUAL_DETONATE;
			client_print(id, print_chat, "[COD:MW] Wybrales reczna detonacje!");
			client_print(id, print_chat, "[COD:MW] By otrzymac detonatora, wybierz noz!");
			client_print(id, print_chat, "[COD:MW] Nacisnij LPM, aby zdetonowac mine!");
		}
	}
	menu_destroy(menu);
	return PLUGIN_CONTINUE
}
public M18_Detonate_Manual(ent)
{
	entity_set_int(ent, EV_INT_iuser1, 1);
		
	new attacker = pev(ent, pev_owner);
	
	new Float:fOrigin[3], iOrigin[3];
	pev(ent, pev_origin, fOrigin);
	
	FVecIVec(fOrigin, iOrigin);
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY, iOrigin);
	write_byte(TE_EXPLOSION);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]);
	write_short(sprite_blast);
	write_byte(32); 
	write_byte(20); 
	write_byte(0);
	message_end();
		
	new entlist[33];
	new numfound = find_sphere_class(ent,"player", 300.0 ,entlist, 32);
		
	for (new i=0; i < numfound; i++)
	{		
		new pid = entlist[i];
			
		if (!is_user_alive(pid) || get_user_team(attacker) == get_user_team(pid))
			continue;
				
		cod_inflict_damage(attacker, pid, 100.0, 1.0, ent, (1<<24));
	}
	M18_detonate[attacker] = DETONATE_NONE;
	remove_entity(ent);
	return PLUGIN_CONTINUE
}
public M18_Detonate_Scan(ent)
{
	if(!is_valid_ent(ent))
		return PLUGIN_CONTINUE;
		
	new attacker = pev(ent, pev_owner)
	new bool: bDetonate = false;
	
	if(M18_detonate[attacker] != SCAN_DETONATE)
		return PLUGIN_CONTINUE;
		
	if(entity_get_int(ent, EV_INT_iuser2))
		return PLUGIN_CONTINUE;
	
	entity_set_int(ent, EV_INT_iuser1, 1);
		

		
	new Float:fOrigin[3];
	entity_get_vector(ent, EV_VEC_origin, fOrigin);
	
	new entlist[33];
	new numfound = find_sphere_class(ent,"player", 300.0 ,entlist, 32);

	for (new i=0; i < numfound; i++)
	{
		new pid = entlist[i];
		new origin[3], Float: porigin[3];
		get_user_origin(entlist[i], origin);
		IVecFVec(origin, porigin);
		if (is_user_alive(pid) && get_user_team(attacker) != get_user_team(pid) && get_distance_f(porigin, fOrigin) <= 150.0)
		{
			new iOrigin[3];
			FVecIVec(fOrigin, iOrigin)
			message_begin(MSG_BROADCAST,SVC_TEMPENTITY, iOrigin);
			write_byte(TE_EXPLOSION);
			write_coord(iOrigin[0]);
			write_coord(iOrigin[1]);
			write_coord(iOrigin[2]);
			write_short(sprite_blast);
			write_byte(32); 
			write_byte(20); 
			write_byte(0);
			message_end();
			bDetonate = true;
			break;
		}
	}
	if(bDetonate)
	{
		for (new i=0; i < numfound; i++)
		{
			new pid = entlist[i];
			new origin[3], Float: porigin[3];
			get_user_origin(entlist[i], origin);
			IVecFVec(origin, porigin);
			if (is_user_alive(pid) && get_user_team(attacker) != get_user_team(pid))
			{
				cod_inflict_damage(attacker, pid, 100.0, 1.0, ent, (1<<24));
			}
		}
		M18_detonate[attacker] = DETONATE_NONE;
		remove_entity(ent)
		return PLUGIN_CONTINUE;
	}
	new iOrigin[3];
	FVecIVec(fOrigin, iOrigin);
			
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY, iOrigin );
	write_byte(TE_BEAMCYLINDER);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1] + 250);
	write_coord(iOrigin[2] + 250);
	write_short(sprite_white);
	write_byte(0); // startframe
	write_byte(0); // framerate
	write_byte(10); // life
	write_byte(10); // width
	write_byte(255); // noise
	write_byte(0); // r, g, b
	write_byte(100 );// r, g, b
	write_byte( 255 ); // r, g, b
	write_byte( 4); // brightness
	write_byte( 0 ); // speed
	message_end();

	entity_set_float(ent, EV_FL_nextthink, halflife_time() + 0.3);	
	
	return PLUGIN_CONTINUE;
}
public NowaRunda()
{
	new ent = find_ent_by_class(-1, "claymore");
	while(ent > 0) 
	{
		M18_detonate[pev(ent, pev_owner)] = DETONATE_NONE
		M18_planting[pev(ent, pev_owner)] = PLANT_NONE
		remove_entity(ent);
		ent = find_ent_by_class(ent, "claymore");	
	}
	freezetime = true;
}
public client_disconnect(id)
{
	new ent = find_ent_by_class(0, "claymore");
	while(ent > 0)
	{
		if(pev(ent, pev_owner) == id)
			remove_entity(ent);
		ent = find_ent_by_class(ent, "claymore");
	}
}
public PoczatekRundy()	
{
	freezetime = false;
}
