#include < amxmodx >
#include < orpheu >
#include < orpheu_stocks >

/***** edit here *****/
const FFADE_MODULATE = 0x0002;
const Amplitude = 0x3FC000;
const Frequency = 0x3FC000;
const Duration = 0x1000;
const HoldTime = 0x1000;
const Red = 0xFF;
const Green = 0x0;
const Blue = 0x0;
const Alpha = 0x7F;
/***** end edit *****/

new OrpheuStruct:h_struct_pmove;

new g_msgScreenShake, g_msgScreenFade;

public plugin_init( ) {
	register_plugin( "Hells Path", "1.0", "Ortega" );
	
	OrpheuRegisterHook( OrpheuGetDLLFunction( "pfnPM_Move","PM_Move" ), "OnPM_Move" );
	OrpheuRegisterHook( OrpheuGetFunction( "PM_PlayerMove" ), "OnPM_PlayerMove", OrpheuHookPost );
	
	g_msgScreenShake = get_user_msgid( "ScreenShake" );
	g_msgScreenFade = get_user_msgid( "ScreenFade" );
	
}

public OrpheuHookReturn:OnPM_Move( pmove, server ) {
	h_struct_pmove = OrpheuGetStructFromParam( 0x1 );
	return OrpheuIgnored;	
}

public OrpheuHookReturn:OnPM_PlayerMove( server ) {
	new id = OrpheuGetStructMember( h_struct_pmove, "player_index" ) + 0x1;
	
	if( !OrpheuGetStructMember( h_struct_pmove, "dead" ) )
	{
		set_hell( id );
	}
	return OrpheuIgnored;
}

set_hell( id ) {
	message_begin( MSG_ONE, g_msgScreenShake, { 0x0, 0x0, 0x0 }, id );
	write_short( Amplitude );
	write_short( Duration );
	write_short( Frequency ); 
	message_end( );
	
	message_begin( MSG_ONE, g_msgScreenFade, { 0x0, 0x0, 0x0 }, id );
	write_short( HoldTime );
	write_short( Duration );
	write_short( FFADE_MODULATE );
	write_byte( Red );
	write_byte( Green );
	write_byte( Blue );
	write_byte( Alpha );
	message_end( );
	
}
