#include <amxmodx>
#include <colorchat>
#include <fakemeta>
#include <hamsandwich>

#define PLUGIN "Info po smierci"
#define VERSION "1.0"
#define AUTHOR "DarkGL"

#define MAX 32

new bool:bCanSay[ MAX+1 ]

new Float: timeCvarSay;

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	timeCvarSay = get_pcvar_float( register_cvar( "info_smierci_czas","5.0" ) );
	
	register_event("DeathMsg", "DeathMsg", "a");
	
	RegisterHam( Ham_Spawn , "player" , "fwSpawned" , 1 );
	
	register_clcmd("say","sayHandle")
	register_clcmd("say_team","sayHandle")
	
	register_forward(FM_Voice_SetClientListening, "Forward_SetClientListening");
}

public client_connect( id ){
	bCanSay[ id ] = false;
	
	remove_task( id );
}

public client_disconnect( id ){
	bCanSay[ id ] = false;
	
	remove_task( id );
}


public fwSpawned( id ){
	
	if( is_user_alive( id ) ){
		bCanSay[ id ] = false;
	}
	
}

public sayHandle(id){
	
	if( !bCanSay[ id ] ){
		return PLUGIN_CONTINUE;
	}
	
	new szTmp[128],szPrint[190],szName[64];
	
	read_argv( 1 , szTmp , charsmax(szTmp) );
	trim( szTmp )
	
	get_user_name( id , szName , charsmax( szName ) );
	
	formatex( szPrint,charsmax( szPrint ),"[Info od %s] ^x01 %s", szName , szTmp );
	
	ColorChat( id,GREEN,szPrint );
	
	for(new iCurrent = 1;iCurrent <= MAX; iCurrent++ ){
		
		if( !is_user_alive( iCurrent ) || get_pdata_int( iCurrent , 114 ) != get_pdata_int( id , 114 ) ){
			continue;
		}
		
		ColorChat( iCurrent ,GREEN,szPrint );
	}
	
	bCanSay[ id ] = false;
	
	return PLUGIN_HANDLED;
}

public DeathMsg(){
		
	new victimID = read_data(2)
	
	if( is_user_connected( victimID ) && !is_user_alive( victimID ) ){
		
		remove_task( victimID );
		
		bCanSay[ victimID ] = true;
		
		set_task( timeCvarSay ,"stopInfo", victimID )
	}
}

public stopInfo(id){
	if( is_user_connected( id ) ){
		engclient_cmd( id , "-voicerecord" );
	}
	
	bCanSay[ id ] = false;
}

public Forward_SetClientListening( iReceiver, iSender, bool:bListen ) {
	if(!is_user_connected( iSender ) || !is_user_connected( iReceiver ) || !bCanSay[iSender] || get_pdata_int( iSender , 114 ) != get_pdata_int( iReceiver, 114 ) ){
		return FMRES_IGNORED;
	}
	
	engfunc( EngFunc_SetClientListening, iReceiver, iSender, true );
	forward_return( FMV_CELL, true );
	
	return FMRES_SUPERCEDE
}
